// ----------------------------------------------------------------------------
// config.h  --  user configuration items for fldigi
//
// Copyright (C) 2006
//		Dave Freese, W1HKJ
//
// This file is part of fldigi.  Adapted in part from code contained in gmfsk 
// source code distribution.
//
// fldigi is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// fldigi is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with fldigi; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// ----------------------------------------------------------------------------

#ifndef _CONFIG_H
#define _CONFIG_H

// You can change the width of the waterfall / spectrum display by modifying this
// constant.
// Suggest that you make the value a multiple of 100.
// DO NOT EXCEED 4000
// The larger the number the greater the cpu load will be for creating the
// waterfall display

#define IMAGE_WIDTH 3000

// Sweet spot - the frequency to which your transceiver / receiver centers
// the signals when you change the bandwidth
// This frequency will be used to compute the new frequency for the transceiver
// and fldigi audio when you press the QSY button.
// Only valid when using a hamlib enabled rig.

// For example in the Argonaut V it is 1100 Hz

// Many rigs center for CW ops differently than for SSB.  If you are using your
// narrow CW filters in such a rig you will want to set the CW_SWEET_SPOT to that
// center frequency, that might be for example 600 Hz.  

// for the Icom 746 PRO
#define SWEET_SPOT		1500
#define CW_SWEET_SPOT	1500

// color scheme 1 is the fldigi color scheme
// color scheme 2 is the gmfsk-hkj color / grayscale spectra
// comment out one or the other but not both
// This will be the color scheme used for "Multi-color waterfall"

//#define COLOR_SCHEME_1
#define COLOR_SCHEME_2

#endif
