#ifndef _CONFIGURATION_H
#define _CONFIGURATION_H

#include <iostream>
#include <fstream>

#include "main.h"
#include "rtty.h"

using namespace std;

struct configuration {
	int		afcon;
	int		squelchon;
	int		stopflag;
	int		tune;
	int		fragmentsize;
	int		samplerate;
	bool	reverse;
	int		sigsearch;

	bool	freqlock;
	double	bandwidth;
	double	frequency;
	double	freqerr;
	double	tx_frequency;
	double	tx_offset;
	
	double 	squelch;
	double	metric;
	double	syncpos;
// RTTY
	double		rtty_squelch;
	int			rtty_shift;
	int			rtty_baud;
	int 		rtty_bits;
	int			rtty_parity;
	int			rtty_stop;
	bool 		rtty_reverse;
	bool		rtty_msbfirst;
// CW
	bool	cwTrack;
	bool	cwLock;
	double	cwRcvWPM;
	double	cwXmtWPM;
// Operator data
	string	myCall;
	string	myQth;
	string	myName;
	string	myLocator;
// Interface data
	int		btnPTTis;
	int		btnRTSDTRis;
	int		btnPTTREVis;
	int		choiceHAMLIBis;
public:
	void readDefaults(ifstream &f);
	void writeDefaults(ofstream &f);
	void storeDefaults();
	void loadDefaults();
	void saveDefaults();
	int  openDefaults();
	void initOperator();
	void initInterface();
	
	friend std::istream &operator>>(std::istream &stream, configuration &c);
	friend std::ostream &operator<<(std::ostream &ostream, configuration c);
};

extern configuration progdefaults;

#endif
